com.smartgwt.client.widgets.form.fields

## Class SetFilterItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.data.Field
        - - com.smartgwt.client.widgets.form.fields.FormItem
          - - com.smartgwt.client.widgets.form.fields.StaticTextItem
            - - com.smartgwt.client.widgets.form.fields.MultiPickerItem
              - - com.smartgwt.client.widgets.form.fields.SetFilterItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPendingStatusChangedHandlers, HasPickerIconClickHandlers, HasShowContextMenuHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers, HasValueIconClickHandlers

      public class SetFilterItem
      extends MultiPickerItem

  Specialized `MultiPickerItem` used for generating search criteria in the `FilterEditor` and in SearchForms.

  SetFilterItem generates `inSet and notInSet` filter criteria from a set of possible values, which can be provided via an explicit `valueMap` or `optionDataSource`, or can be derived from the `target databound component` or a `list of records`.

  In particular, when attached to a databound component such as a ListGrid, SetFilterItem can provide "Excel-style filtering", allowing the user to pick from amongst whatever values are present in the dataset.

  For large datasets, SetFilterItem will also intelligently use locally cached data when possible, deriving its set of options from loaded data without the need for an extra dataSource fetch. Specifically, when `all matching records` are loaded in the `filterTargetComponent`, the options are derived from already loaded data. If the set of data is incomplete (due to `data paging`), the SetFilterItem will derive options from its optionDataSource.

  Note that `deriveUniqueValues` defaults to `true` for setFilterItems.

  When a SetFilterItem is used as a `ListGrid filterEditor`, the filterTargetComponent will automatically be set to the grid being filtered.

  The item's picker-component can be customized via settings such as `sortField`, or by configuring `auto-children` like the `search-form`, the `main pickList-grid` or the separate list of `selected values`. You can use `MultiPickerItem.optionFilterContext` to apply custom `requestProperties` to fetches from the main `pickList` grid.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `FormItem.CustomStateGetter, FormItem.StateCustomizer`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `configOnly, scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SetFilterItem()`
    `SetFilterItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `SetFilterItem(java.lang.String name)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `java.lang.Boolean` | `getCanExpand()` Should we show an `MultiPickerItem.expansionIcon` expand button allowing the user to show an expanded view of the `MultiPickerItem.pickList` with multiple fields.
    `java.lang.Boolean` | `getDefaultUseUnselectedValues()` Should this item track unselected or selected values by default?
    `java.lang.Boolean` | `getDeriveUniqueValues()` If this MultiPickerItem is deriving its options from a dataSource, should it ensure unique field values by `grouping by` the value field for this item? This is not necessary if the target dataSource value field is already unique - for example if this is the primaryKey field for a dataSource.
    `ListGridField[]` | `getExpandedPickListFields()` If `canExpand` is true, this is the list of fields to display in the PickList or `pickTree` when the picker is expanded
    `DataBoundComponent` | `getFilterTargetComponent()` Target component for which this SetFilterItem is generating criteria.
    `static SetFilterItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `OperatorId` | `getSelectedOperator()` Operator for the criteria generated by this item when `useUnselectedValues` is false.
    `MultiPickerSelectionStyle` | `getSelectionStyle()` selectionStyle:"shuttle" is not supported for SetFilterItem
    `java.lang.Boolean` | `getToggleUseUnselectedValuesOnSelectAll()` Should this item toggle between tracking selected options and using them to generate "inSet" criteria and unselected options and using them to generate "notInSet" criteria when the user clicks the `MultiPickerItem.selectAllButton` and `MultiPickerItem.deselectAllButton` on an unfiltered list of options.
    `OperatorId` | `getUnselectedOperator()` Operator for the criteria generated by this item when `useUnselectedValues` is true.
    `java.lang.Boolean` | `getUseUnselectedValues()` The SetFilterItem has the capability to treat its set of options as selected by default, and explicitly track the options a user has unselected, or treat them as unselected by default and explicitly track the user-selected objects.
    `SetFilterItem` | `setCanExpand(java.lang.Boolean canExpand)` Should we show an `MultiPickerItem.expansionIcon` expand button allowing the user to show an expanded view of the `MultiPickerItem.pickList` with multiple fields.
    `static void` | `setDefaultProperties(SetFilterItem setFilterItemProperties)` Class level method to set the default properties of this class.
    `SetFilterItem` | `setDefaultUseUnselectedValues(java.lang.Boolean defaultUseUnselectedValues)` Should this item track unselected or selected values by default?
    `SetFilterItem` | `setDeriveUniqueValues(java.lang.Boolean deriveUniqueValues)` If this MultiPickerItem is deriving its options from a dataSource, should it ensure unique field values by `grouping by` the value field for this item? This is not necessary if the target dataSource value field is already unique - for example if this is the primaryKey field for a dataSource.
    `SetFilterItem` | `setExpandedPickListFields(ListGridField... expandedPickListFields)` If `canExpand` is true, this is the list of fields to display in the PickList or `pickTree` when the picker is expanded
    `SetFilterItem` | `setFilterTargetComponent(DataBoundComponent filterTargetComponent)` Target component for which this SetFilterItem is generating criteria.
    `SetFilterItem` | `setSelectedOperator(OperatorId selectedOperator)` Operator for the criteria generated by this item when `useUnselectedValues` is false.
    `SetFilterItem` | `setSelectionStyle(MultiPickerSelectionStyle selectionStyle)` selectionStyle:"shuttle" is not supported for SetFilterItem
    `SetFilterItem` | `setToggleUseUnselectedValuesOnSelectAll(java.lang.Boolean toggleUseUnselectedValuesOnSelectAll)` Should this item toggle between tracking selected options and using them to generate "inSet" criteria and unselected options and using them to generate "notInSet" criteria when the user clicks the `MultiPickerItem.selectAllButton` and `MultiPickerItem.deselectAllButton` on an unfiltered list of options.
    `SetFilterItem` | `setUnselectedOperator(OperatorId unselectedOperator)` Operator for the criteria generated by this item when `useUnselectedValues` is true.
    `SetFilterItem` | `setUseUnselectedValues(java.lang.Boolean useUnselectedValues)` The SetFilterItem has the capability to treat its set of options as selected by default, and explicitly track the options a user has unselected, or treat them as unselected by default and explicitly track the user-selected objects.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.MultiPickerItem

      `getCanSelectFolders, getCascadeSelection, getCollapseIconSrc, getDeselectAllButton, getDeselectAllButtonTitle, getDeselectAllWhileFiltered_disabledPrompt, getDeselectAllWhileFiltered_partialCachePrompt, getDisplayField, getExpandIconSrc, getExpansionHeight, getExpansionIcon, getExpansionWidth, getFilterForm, getFilterHint, getFilterIcon, getFilterIconHeight, getFilterIconSrc, getFilterIconWidth, getFilterPickListOnKeypress, getIncludeSelectedParents, getInitialSort, getMultiple, getOptionCriteria, getOptionDataSource, getOptionFilterContext, getOptionOperationId, getPickerLayout, getPickerToolbar, getPickList, getPickListFetchDelay, getPickListHeight, getPickListWidth, getPickTree, getSelectAllButton, getSelectAllButtonTitle, getSelectAllWhileFiltered_disabledPrompt, getSelectAllWhileFiltered_partialCachePrompt, getSelectAllWhileFiltered, getSelectedSelectionListTitle, getSelectionList, getSelectionListLabel, getShowFilterForm, getShowSelectionLabel, getShowSelectionList, getShuttle, getShuttleHeight, getShuttleWidth, getSortDirection, getSortField, getSortFieldAsInt, getSortFieldAsStringArray, getTextMatchStyle, getValueField, getValueFieldName, setCanSelectFolders, setCascadeSelection, setCollapseIconSrc, setDefaultProperties, setDeselectAllButtonTitle, setDeselectAllWhileFiltered_disabledPrompt, setDeselectAllWhileFiltered_partialCachePrompt, setDisplayField, setExpandIconSrc, setExpansionHeight, setExpansionWidth, setFilterHint, setFilterIconHeight, setFilterIconSrc, setFilterIconWidth, setFilterPickListOnKeypress, setIncludeSelectedParents, setInitialSort, setMultiple, setOptionCriteria, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setPickListFetchDelay, setPickListHeight, setPickListWidth, setSelectAllButtonTitle, setSelectAllWhileFiltered_disabledPrompt, setSelectAllWhileFiltered_partialCachePrompt, setSelectAllWhileFiltered, setSelectedSelectionListTitle, setShowFilterForm, setShowSelectionLabel, setShowSelectionList, setShuttleHeight, setShuttleWidth, setSortDirection, setSortField, setSortField, setSortField, setTextMatchStyle, setValueField`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.StaticTextItem

      `getApplyAlignToText, getApplyHeightToTextBox, getCanSelectText, getClipValue, getDateFormatter, getDefaultValue, getEditProxyConstructor, getEscapeHTML, getTextBoxStyle, getWrap, setApplyAlignToText, setApplyHeightToTextBox, setCanSelectText, setClipValue, setDateFormatter, setDefaultProperties, setEditProxyConstructor, setEscapeHTML, setTextBoxStyle, setWrap`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIcon, addIcon, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addShowContextMenuHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, applyFormula, asSGWTComponent, blurItem, canEditCriterion, checkFormItemType, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusAfterItem, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getAlwaysShowControlBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getAutoCompleteKeywords, getBrowserInputType, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanFocus, getCanHover, getCanTabToIcons, getCanvasAutoChild, getCellHeight, getCellStyle, getChangeOnKeypress, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDefaultOperator, getDestroyed, getDisabled, getDisabledHover, getDisableIconsOnReadOnly, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconProperties, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getExportFormat, getExtraControlTableCSS, getExtraTextBoxCSS, getFetchMissingValues, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFormula, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHeight, getHeightAsString, getHidden, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHeightAsString, getHoverOpacity, getHoverPersist, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWidthAsString, getIcon, getIconBaseStyle, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIcons, getIconTabPosition, getIconVAlign, getIconWidth, getID, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getLinearColSpan, getLinearColSpanAsString, getLinearEndRow, getLinearEndRowAsString, getLinearStartRow, getLinearStartRowAsString, getLinearWidth, getLinearWidthAsString, getListGrid, getLoadingDisplayValue, getLocateItemBy, getMinHintWidth, getMultipleValueSeparator, getName, getNullOriginalValueText, getOperator, getOptionDataSourceAsString, getOptionTextMatchStyle, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPaletteDefaults, getPicker, getPickerIcon, getPickerIcon, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconTabPosition, getPickerIconWidth, getPixelHeight, getPixelWidth, getPrintReadOnlyTextBoxStyle, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyCanSelectText, getReadOnlyControlStyle, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getReadOnlyWhen, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRequiredRightTitlePrefix, getRequiredRightTitleSuffix, getRequiredTitlePrefix, getRequiredTitleSuffix, getRequiredWhen, getRightTitlePrefix, getRightTitleSuffix, getRowSpan, getSaveOnEnter, getScClassName, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShouldSaveValue, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowDisabledIconsOnFocus, getShowDisabledPickerIconOnFocus, getShowErrorIcon, getShowErrorIconInline, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowIconsOnFocus, getShowImageAsURL, getShowOldValueInHover, getShowOver, getShowOverIcons, getShowPending, getShowPickerIcon, getShowPickerIconOnFocus, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStaticHeight, getStopOnError, getStoreDisplayValues, getSupportsCutPasteEvents, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextFormula, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitlePrefix, getTitleStyle, getTitleSuffix, getTitleVAlign, getTooltip, getTop, getType, getUpdateControlOnOver, getUpdatePickerIconOnOver, getUpdateTextBoxOnOver, getUseAdvancedCriteria, getUseDisabledHintStyleForReadOnly, getUseLocalDisplayFieldValue, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsFloat, getValueAsInteger, getValueAsLong, getValueAsRecordList, getValueDeselectedCSSText, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getValueMap, getValueMapAsArray, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWhen, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapHintText, getWrapStaticValue, getWrapTitle, handleWarnOnEditorTypeConversion, hasAdvancedCriteria, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isAssignableFrom, isConfigOnly, isCreated, isCutEvent, isDisabled, isDrawn, isFocused, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, removeIcon, selectedRecordChanged, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setAlwaysShowControlBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setAutoCompleteKeywords, setBrowserInputType, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanEditOpaqueValues, setCanFocus, setCanHover, setCanTabToIcons, setCellHeight, setCellStyle, setChangeOnKeypress, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setConfigOnly, setControlStyle, setCriteriaField, setCriterion, setCriterionGetter, setCriterionSetter, setCustomStateGetter, setDataPath, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultOperator, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisabledHover, setDisableIconsOnReadOnly, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconProperties, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setExportFormat, setExtraControlTableCSS, setExtraTextBoxCSS, setFetchMissingValues, setFilterLocally, setForeignDisplayField, setFormat, setFormula, setGlobalTabIndex, setHeight, setHeight, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverHeight, setHoverOpacity, setHoverPersist, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWidth, setIconBaseStyle, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconShowOnFocus, setIconVAlign, setIconWidth, setID, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLinearColSpan, setLinearColSpan, setLinearEndRow, setLinearEndRow, setLinearStartRow, setLinearStartRow, setLinearWidth, setLinearWidth, setLoadingDisplayValue, setLocateItemBy, setMinHintWidth, setMultipleValueSeparator, setName, setNullOriginalValueText, setNullProperty, setOperator, setOptionDataSource, setOptionFilterContext, setOptionTextMatchStyle, setOriginalValueMessage, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintReadOnlyTextBoxStyle, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyCanSelectText, setReadOnlyControlStyle, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setReadOnlyWhen, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRequiredRightTitlePrefix, setRequiredRightTitleSuffix, setRequiredTitlePrefix, setRequiredTitleSuffix, setRequiredWhen, setRightTitlePrefix, setRightTitleSuffix, setRowSpan, setSaveOnEnter, setScClassName, setSelectOnClick, setSelectOnFocus, setShouldSaveValue, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowDisabledIconsOnFocus, setShowDisabledPickerIconOnFocus, setShowErrorIcon, setShowErrorIconInline, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIconsOnFocus, setShowIfCondition, setShowImageAsURL, setShowOldValueInHover, setShowOver, setShowOverIcons, setShowPending, setShowPickerIcon, setShowPickerIconOnFocus, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setStoreDisplayValues, setSupportsCutPasteEvents, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextFormula, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitlePrefix, setTitleStyle, setTitleSuffix, setTitleVAlign, setTooltip, setTop, setType, setUpdateControlOnOver, setUpdatePickerIconOnOver, setUpdateTextBoxOnOver, setUseAdvancedCriteria, setUseDisabledHintStyleForReadOnly, setUseLocalDisplayFieldValue, setUseObjectFactoryForTypeFallback, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueDeselectedCSSText, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setVisibleWhen, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapHintText, setWrapStaticValue, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, storeValue, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.data.Field

      `getCanExport, getExportTitle, getSortByField, setCanExport, setExportTitle, setSortByField`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### SetFilterItem

          public SetFilterItem()

    - #### SetFilterItem

          public SetFilterItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### SetFilterItem

          public SetFilterItem(java.lang.String name)

  - ### Method Detail

    - #### getOrCreateRef

          public static SetFilterItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setCanExpand

          public SetFilterItem setCanExpand(java.lang.Boolean canExpand)

      Should we show an `MultiPickerItem.expansionIcon` expand button allowing the user to show an expanded view of the `MultiPickerItem.pickList` with multiple fields.

      `canExpand` only applies to MultiPickerItems with selectionStyle set to "pickList" or "pickTree" and an explicitly specified set of `MultiPickerItem.expandedPickListFields` to display within the expanded view.

      Overrides:
        `setCanExpand` in class `MultiPickerItem`
      Parameters:
        `canExpand` - New canExpand value. Default value is false
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getCanExpand

          public java.lang.Boolean getCanExpand()

      Should we show an `MultiPickerItem.expansionIcon` expand button allowing the user to show an expanded view of the `MultiPickerItem.pickList` with multiple fields.

      `canExpand` only applies to MultiPickerItems with selectionStyle set to "pickList" or "pickTree" and an explicitly specified set of `MultiPickerItem.expandedPickListFields` to display within the expanded view.

      Overrides:
        `getCanExpand` in class `MultiPickerItem`
      Returns:
        Current canExpand value. Default value is false

    - #### setDefaultUseUnselectedValues

          public SetFilterItem setDefaultUseUnselectedValues(java.lang.Boolean defaultUseUnselectedValues)

      Should this item track unselected or selected values by default?

      If `toggleUseUnselectedValuesOnSelectAll`, for setFilterItems with no current criteria (I.E. no explicitly selected or unselected values), this property will be evaluated when the pickList is shown and `useUnselectedValues` will be set to match this value. This causes the options in the pickList to always show up checked (or unchecked) by default, matching user expectations of what an "empty" filter represents.

      May be set to null, in which case useUnselectedValues will not be modified when the pickList is shown for an empty SetFilterItem

      Note : This is an advanced setting

      Parameters:
        `defaultUseUnselectedValues` - New defaultUseUnselectedValues value. Default value is true
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getDefaultUseUnselectedValues

          public java.lang.Boolean getDefaultUseUnselectedValues()

      Should this item track unselected or selected values by default?

      If `toggleUseUnselectedValuesOnSelectAll`, for setFilterItems with no current criteria (I.E. no explicitly selected or unselected values), this property will be evaluated when the pickList is shown and `useUnselectedValues` will be set to match this value. This causes the options in the pickList to always show up checked (or unchecked) by default, matching user expectations of what an "empty" filter represents.

      May be set to null, in which case useUnselectedValues will not be modified when the pickList is shown for an empty SetFilterItem

      Returns:
        Current defaultUseUnselectedValues value. Default value is true

    - #### setDeriveUniqueValues

          public SetFilterItem setDeriveUniqueValues(java.lang.Boolean deriveUniqueValues)

      If this MultiPickerItem is deriving its options from a dataSource, should it ensure unique field values by `grouping by` the value field for this item? This is not necessary if the target dataSource value field is already unique - for example if this is the primaryKey field for a dataSource.

      Note that for MultiPickerItems with `deriveUniqueValues:true`, any `expandedPickListFields` to be displayed in the `expanded view` will not be able to display meaningful values unless a `summaryFunction` is supplied to produce aggregated values from the grouped data. This may be achieved by specifying summaryFunctions directly on the `optionFilterContext`, or on the `operationBinding` for the `fetch operation`.

      Note : This is an advanced setting

      Overrides:
        `setDeriveUniqueValues` in class `MultiPickerItem`
      Parameters:
        `deriveUniqueValues` - New deriveUniqueValues value. Default value is true
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getDeriveUniqueValues

          public java.lang.Boolean getDeriveUniqueValues()

      If this MultiPickerItem is deriving its options from a dataSource, should it ensure unique field values by `grouping by` the value field for this item? This is not necessary if the target dataSource value field is already unique - for example if this is the primaryKey field for a dataSource.

      Note that for MultiPickerItems with `deriveUniqueValues:true`, any `expandedPickListFields` to be displayed in the `expanded view` will not be able to display meaningful values unless a `summaryFunction` is supplied to produce aggregated values from the grouped data. This may be achieved by specifying summaryFunctions directly on the `optionFilterContext`, or on the `operationBinding` for the `fetch operation`.

      Overrides:
        `getDeriveUniqueValues` in class `MultiPickerItem`
      Returns:
        Current deriveUniqueValues value. Default value is true

    - #### setExpandedPickListFields

          public SetFilterItem setExpandedPickListFields(ListGridField... expandedPickListFields)

      If `canExpand` is true, this is the list of fields to display in the PickList or `pickTree` when the picker is expanded
      Overrides:
        `setExpandedPickListFields` in class `MultiPickerItem`
      Parameters:
        `expandedPickListFields` - New expandedPickListFields value. Default value is null
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getExpandedPickListFields

          public ListGridField[] getExpandedPickListFields()

      If `canExpand` is true, this is the list of fields to display in the PickList or `pickTree` when the picker is expanded
      Overrides:
        `getExpandedPickListFields` in class `MultiPickerItem`
      Returns:
        Current expandedPickListFields value. Default value is null

    - #### setFilterTargetComponent

          public SetFilterItem setFilterTargetComponent(DataBoundComponent filterTargetComponent)

      Target component for which this SetFilterItem is generating criteria. By default the `sourceList` will be the `data object` for the target component, and the option dataSource, option criteria, option fetch operation and so on will be derived from the target component's configuration.

      For a setFilterItem embedded in a `filter editor`, this will be the target listGrid.

      Parameters:
        `filterTargetComponent` - New filterTargetComponent value. Default value is null
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getFilterTargetComponent

          public DataBoundComponent getFilterTargetComponent()

      Target component for which this SetFilterItem is generating criteria. By default the `sourceList` will be the `data object` for the target component, and the option dataSource, option criteria, option fetch operation and so on will be derived from the target component's configuration.

      For a setFilterItem embedded in a `filter editor`, this will be the target listGrid.

      Returns:
        Current filterTargetComponent value. Default value is null

    - #### setSelectedOperator

          public SetFilterItem setSelectedOperator(OperatorId selectedOperator)

      Operator for the criteria generated by this item when `useUnselectedValues` is false.

      Note : This is an advanced setting

      Parameters:
        `selectedOperator` - New selectedOperator value. Default value is "inSet"
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getSelectedOperator

          public OperatorId getSelectedOperator()

      Operator for the criteria generated by this item when `useUnselectedValues` is false.
      Returns:
        Current selectedOperator value. Default value is "inSet"

    - #### setSelectionStyle

          public SetFilterItem setSelectionStyle(MultiPickerSelectionStyle selectionStyle)

      selectionStyle:"shuttle" is not supported for SetFilterItem
      Overrides:
        `setSelectionStyle` in class `MultiPickerItem`
      Parameters:
        `selectionStyle` - New selectionStyle value. Default value is "pickList"
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getSelectionStyle

          public MultiPickerSelectionStyle getSelectionStyle()

      selectionStyle:"shuttle" is not supported for SetFilterItem
      Overrides:
        `getSelectionStyle` in class `MultiPickerItem`
      Returns:
        Current selectionStyle value. Default value is "pickList"

    - #### setToggleUseUnselectedValuesOnSelectAll

          public SetFilterItem setToggleUseUnselectedValuesOnSelectAll(java.lang.Boolean toggleUseUnselectedValuesOnSelectAll)

      Should this item toggle between tracking selected options and using them to generate "inSet" criteria and unselected options and using them to generate "notInSet" criteria when the user clicks the `MultiPickerItem.selectAllButton` and `MultiPickerItem.deselectAllButton` on an unfiltered list of options.

      See `useUnselectedValues` for more detail

      Note : This is an advanced setting

      Parameters:
        `toggleUseUnselectedValuesOnSelectAll` - New toggleUseUnselectedValuesOnSelectAll value. Default value is true
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getToggleUseUnselectedValuesOnSelectAll

          public java.lang.Boolean getToggleUseUnselectedValuesOnSelectAll()

      Should this item toggle between tracking selected options and using them to generate "inSet" criteria and unselected options and using them to generate "notInSet" criteria when the user clicks the `MultiPickerItem.selectAllButton` and `MultiPickerItem.deselectAllButton` on an unfiltered list of options.

      See `useUnselectedValues` for more detail

      Returns:
        Current toggleUseUnselectedValuesOnSelectAll value. Default value is true

    - #### setUnselectedOperator

          public SetFilterItem setUnselectedOperator(OperatorId unselectedOperator)

      Operator for the criteria generated by this item when `useUnselectedValues` is true.

      Note : This is an advanced setting

      Parameters:
        `unselectedOperator` - New unselectedOperator value. Default value is "notInSet"
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getUnselectedOperator

          public OperatorId getUnselectedOperator()

      Operator for the criteria generated by this item when `useUnselectedValues` is true.
      Returns:
        Current unselectedOperator value. Default value is "notInSet"

    - #### setUseUnselectedValues

          public SetFilterItem setUseUnselectedValues(java.lang.Boolean useUnselectedValues)

      The SetFilterItem has the capability to treat its set of options as selected by default, and explicitly track the options a user has unselected, or treat them as unselected by default and explicitly track the user-selected objects. This attribute denotes whether the item is currently tracking explicitly selected or unselected values.

      While tracking selected values, this item will generate `inSet` criteria. While tracking unselected values, it will generate `notInSet` criteria.

      If `toggleUseUnselectedValuesOnSelectAll` is true, if the current set of options is unfiltered, the `MultiPickerItem.selectAllButton` and `MultiPickerItem.deselectAllButton` will clear any current value and toggle useUnselectedValues - effectively switching between tracking inclusive (inSet) values and exclusive (notInSet) values.
      If this method is called after the component has been drawn/initialized: Clear any current value for this item and dynamically update `useUnselectedValues`.

      Parameters:
        `useUnselectedValues` - new value for useUnselectedValues. Default value is true
      Returns:
        `SetFilterItem` instance, for chaining setter calls

    - #### getUseUnselectedValues

          public java.lang.Boolean getUseUnselectedValues()

      The SetFilterItem has the capability to treat its set of options as selected by default, and explicitly track the options a user has unselected, or treat them as unselected by default and explicitly track the user-selected objects. This attribute denotes whether the item is currently tracking explicitly selected or unselected values.

      While tracking selected values, this item will generate `inSet` criteria. While tracking unselected values, it will generate `notInSet` criteria.

      If `toggleUseUnselectedValuesOnSelectAll` is true, if the current set of options is unfiltered, the `MultiPickerItem.selectAllButton` and `MultiPickerItem.deselectAllButton` will clear any current value and toggle useUnselectedValues - effectively switching between tracking inclusive (inSet) values and exclusive (notInSet) values.

      Returns:
        Current useUnselectedValues value. Default value is true

    - #### setDefaultProperties

          public static void setDefaultProperties(SetFilterItem setFilterItemProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `setFilterItemProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`